#!/bin/bash

date
echo ===== uptime =====
uptime
echo ===== sysid =====
get_sysid

X=$(cat /var/cage_id)
XX=(${X})
TYPE=${XX[4]}
echo Module type is ${TYPE}

echo ===== node 0 power check =====
X=$(i2c 0:0x60:0=2 0:0x60:0/1)
echo ${X}
XX=(${X})
P0=${XX[4]}
if [ ${TYPE} != 'I/O' ]; then
    echo ===== node 1 power check =====
    X=$(i2c 1:0x60:0=2 1:0x60:0/1)
    echo ${X}
    XX=(${X})
    P1=${XX[4]}
    echo ===== node 2 power check =====
    X=$(i2c 2:0x60:0=2 2:0x60:0/1)
    echo ${X}
    XX=(${X})
    P2=${XX[4]}
fi
echo ===== node 3 power check =====
X=$(i2c 3:0x60:0=2 3:0x60:0/1)
echo ${X}
XX=(${X})
P3=${XX[4]}
if [ ${TYPE} == 'I/O' ]; then
    echo ===== riser 0 power check =====
    X=$(i2c 4:0x60:0=2 4:0x60:0/1)
    echo ${X}
    echo ===== riser 1 power check =====
    X=$(i2c 4:0x61:0=2 4:0x61:0/1)
    echo ${X}
    echo ===== riser 2 power check =====
    X=$(i2c 4:0x62:0=2 4:0x62:0/1)
    echo ${X}
    echo ===== riser 3 power check =====
    X=$(i2c 4:0x63:0=2 4:0x63:0/1)
    echo ${X}
fi
echo ===== verty 0 power check =====
X=$(i2c 5:0x60:0=2 5:0x60:0/1)
echo ${X}
echo ===== verty 1 power check =====
X=$(i2c 5:0x61:0=2 5:0x61:0/1)
echo ${X}
echo ===== verty 2 power check =====
X=$(i2c 5:0x62:0=2 5:0x62:0/1)
echo ${X}
if [ ${TYPE} != 'I/O' ]; then
    echo ===== verty 3 power check =====
    X=$(i2c 5:0x63:0=2 5:0x63:0/1)
    echo ${X}
fi
if [ ${TYPE} == 'Compute-FR2' ]; then
    echo ===== verty 4 power check =====
    X=$(i2c 5:0x64:0=2 5:0x64:0/1)
    echo ${X}
    echo ===== verty 5 power check =====
    X=$(i2c 5:0x65:0=2 5:0x65:0/1)
    echo ${X}
fi
echo ===== mezz power check =====
X=$(i2c 7:0x60:0=2 7:0x60:0/1)
echo ${X}

echo ===== voltages =====
if [ ${TYPE} == 'I/O' ]; then
    vsense 0:0x60 3:0x60 4:0x60 4:0x61 4:0x62 4:0x63 5:0x60 5:0x61 5:0x62 7:0x60
elif [ ${TYPE} == 'Compute-FR2' ]; then
    vsense 0:0x60 1:0x60 2:0x60 3:0x60 5:0x60 5:0x61 5:0x62 5:0x63 5:0x64 7:0x60
else
    vsense 0:0x60 1:0x60 2:0x60 3:0x60 5:0x60 5:0x61 5:0x62 5:0x63 7:0x60
fi

echo ===== temperatures =====
if [ ${TYPE} != 'I/O' ]; then
    tsense 0:0x60 1:0x60 2:0x60 3:0x60 7:0x60
else
    tsense 0:0x60 3:0x60 4:0x60 4:0x61 4:0x62 4:0x63 7:0x60
fi

echo ===== node 0 amps =====
i2c 0:0x60:0=6 0:0x60:0/1
if [ ${TYPE} != 'I/O' ]; then
    echo ===== node 1 amps =====
    i2c 1:0x60:0=6 1:0x60:0/1
    echo ===== node 2 amps =====
    i2c 2:0x60:0=6 2:0x60:0/1
fi
echo ===== node 3 amps =====
i2c 3:0x60:0=6 3:0x60:0/1
echo ===== verty 0 amps =====
i2c 5:0x60:0=6 5:0x60:0/1
echo ===== verty 1 amps =====
i2c 5:0x61:0=6 5:0x61:0/1
echo ===== verty 2 amps =====
i2c 5:0x62:0=6 5:0x62:0/1
if [ ${TYPE} != 'I/O' ]; then
    echo ===== verty 3 amps =====
    i2c 5:0x63:0=6 5:0x63:0/1
fi
if [ ${TYPE} == 'Compute-FR2' ]; then
    echo ===== verty 4 amps =====
    i2c 5:0x64:0=6 5:0x64:0/1
    echo ===== verty 5 amps =====
    i2c 5:0x65:0=6 5:0x65:0/1
fi
echo ===== mezz amps =====
i2c 7:0x60:0=6 7:0x60:0/1

echo ===== node 0 health =====
if [ ${TYPE} == 'Compute-FR2' ]; then
    i2c 0:0x60:0=3 0:0x60:0/5
else
    i2c 0:0x60:0=3 0:0x60:0/3
fi
if [ ${TYPE} != 'I/O' ]; then
    echo ===== node 1 health =====
    if [ ${TYPE} == 'Compute-FR2' ]; then
        i2c 1:0x60:0=3 1:0x60:0/5
    else
        i2c 1:0x60:0=3 1:0x60:0/3
    fi
    echo ===== node 2 health =====
    if [ ${TYPE} == 'Compute-FR2' ]; then
        i2c 2:0x60:0=3 2:0x60:0/5
    else
        i2c 2:0x60:0=3 2:0x60:0/3
    fi
fi
echo ===== node 3 health =====
if [ ${TYPE} == 'Compute-FR2' ]; then
    i2c 3:0x60:0=3 3:0x60:0/5
else
    i2c 3:0x60:0=3 3:0x60:0/3
fi
if [ ${TYPE} == 'I/O' ]; then
    echo ===== riser 0 health =====
    i2c 4:0x60:0=3 4:0x60:0/1
    echo ===== riser 1 health =====
    i2c 4:0x61:0=3 4:0x61:0/1
    echo ===== riser 2 health =====
    i2c 4:0x62:0=3 4:0x62:0/1
    echo ===== riser 3 health =====
    i2c 4:0x63:0=3 4:0x63:0/1
fi
echo ===== verty 0 health =====
i2c 5:0x60:0=3 5:0x60:0/1
echo ===== verty 1 health =====
i2c 5:0x61:0=3 5:0x61:0/1
echo ===== verty 2 health =====
i2c 5:0x62:0=3 5:0x62:0/1
if [ ${TYPE} != 'I/O' ]; then
    echo ===== verty 3 health =====
    i2c 5:0x63:0=3 5:0x63:0/1
fi
if [ ${TYPE} == 'Compute-FR2' ]; then
    echo ===== verty 4 health =====
    i2c 5:0x64:0=3 5:0x64:0/1
    echo ===== verty 5 health =====
    i2c 5:0x65:0=3 5:0x65:0/1
fi
echo ===== mezz health =====
i2c 7:0x60:0=3 7:0x60:0/3

echo ===== node 0 EngReg =====
i2c 0:0x60:0=0x12 0:0x60:0/10
if [ ${TYPE} != 'I/O' ]; then
    echo ===== node 1 EngReg =====
    i2c 1:0x60:0=0x12 1:0x60:0/10
    echo ===== node 2 EngReg =====
    i2c 2:0x60:0=0x12 2:0x60:0/10
fi
echo ===== node 3 EngReg =====
i2c 3:0x60:0=0x12 3:0x60:0/10

# assume we can proceed
HDT=1
#
# For all module types EXCEPT FR2, all nodes must be
# powered on in order for the JTAG chains to be valid
# since the chains go from node to node.  On FR2
# modules, if both sockets of a node are powered on
# then that node's jtag chain is valid and is
# independent of the power state of other nodes.
#
if [ ${P0} != 0x41 -a ${TYPE} != 'Compute-FR2' ]; then
    HDT=0
fi
if [ ${TYPE} != 'I/O' ]; then
    if [ ${P1} != 0x41 -a ${TYPE} != 'Compute-FR2' ]; then
        HDT=0
    fi
    if [ ${P2} != 0x41 -a ${TYPE} != 'Compute-FR2' ]; then
        HDT=0
    fi
fi
if [ ${P3} != 0x41 -a ${TYPE} != 'Compute-FR2' ]; then
    HDT=0
fi

if [ ${HDT} == 1 ]; then
    if [ ${TYPE} == 'Compute-FR2' ]; then
        if [ ${P0} == 0x43 ]; then
            echo ===== node 0 socket 0 core 0 GPRs =====
            hdt -r1 -n0:0
            echo ===== node 0 socket 0 core 1 GPRs =====
            hdt -r1 -n0:1
            echo ===== node 0 socket 0 core 2 GPRs =====
            hdt -r1 -n0:2
            echo ===== node 0 socket 0 core 3 GPRs =====
            hdt -r1 -n0:3
            echo ===== node 0 socket 1 core 0 GPRs =====
            hdt -r1 -n1:0
            echo ===== node 0 socket 1 core 1 GPRs =====
            hdt -r1 -n1:1
            echo ===== node 0 socket 1 core 2 GPRs =====
            hdt -r1 -n1:2
            echo ===== node 0 socket 1 core 3 GPRs =====
            hdt -r1 -n1:3
        else
            echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            echo '! Both sockets of node 0 are NOT powered on !'
            echo '!          hdt will NOT be executed         !'
            echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        fi
    elif [ ${TYPE} == 'Compute-AM2' ]; then
#       We can't tell the difference between AM2 dual
#       core and AM2 quad core so treat them as quad.
        echo ===== node 0 core 0 GPRs =====
        hdt -r1 -n0:0
        echo ===== node 0 core 1 GPRs =====
        hdt -r1 -n0:1
        echo ===== node 0 core 2 GPRs =====
        hdt -r1 -n0:2
        echo ===== node 0 core 3 GPRs =====
        hdt -r1 -n0:3
    else
#       We can't tell the difference between Opteron
#       single core and Opteron dual core so treat
#       them as dual.
        echo ===== node 0 core 0 GPRs =====
        hdt -r1 -n0:0
        echo ===== node 0 core 1 GPRs =====
        hdt -r1 -n0:1
    fi
    if [ ${TYPE} != 'I/O' ]; then
        if [ ${TYPE} == 'Compute-FR2' ]; then
            if [ ${P1} == 0x43 ]; then
                echo ===== node 1 socket 0 core 0 GPRs =====
                hdt -r1 -n2:0
                echo ===== node 1 socket 0 core 1 GPRs =====
                hdt -r1 -n2:1
                echo ===== node 1 socket 0 core 2 GPRs =====
                hdt -r1 -n2:2
                echo ===== node 1 socket 0 core 3 GPRs =====
                hdt -r1 -n2:3
                echo ===== node 1 socket 1 core 0 GPRs =====
                hdt -r1 -n3:0
                echo ===== node 1 socket 1 core 1 GPRs =====
                hdt -r1 -n3:1
                echo ===== node 1 socket 1 core 2 GPRs =====
                hdt -r1 -n3:2
                echo ===== node 1 socket 1 core 3 GPRs =====
                hdt -r1 -n3:3
            else
                echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
                echo '! Both sockets of node 1 are NOT powered on !'
                echo '!          hdt will NOT be executed         !'
                echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            fi
        elif [ ${TYPE} == 'Compute-AM2' ]; then
#           We can't tell the difference between AM2 dual
#           core and AM2 quad core so treat them as quad.
            echo ===== node 1 core 0 GPRs =====
            hdt -r1 -n1:0
            echo ===== node 1 core 1 GPRs =====
            hdt -r1 -n1:1
            echo ===== node 1 core 2 GPRs =====
            hdt -r1 -n1:2
            echo ===== node 1 core 3 GPRs =====
            hdt -r1 -n1:3
        else
#           We can't tell the difference between Opteron
#           single core and Opteron dual core so treat
#           them as dual.
            echo ===== node 1 core 0 GPRs =====
            hdt -r1 -n1:0
            echo ===== node 1 core 1 GPRs =====
            hdt -r1 -n1:1
        fi
        if [ ${TYPE} == 'Compute-FR2' ]; then
            if [ ${P2} == 0x43 ]; then
                echo ===== node 2 socket 0 core 0 GPRs =====
                hdt -r1 -n4:0
                echo ===== node 2 socket 0 core 1 GPRs =====
                hdt -r1 -n4:1
                echo ===== node 2 socket 0 core 2 GPRs =====
                hdt -r1 -n4:2
                echo ===== node 2 socket 0 core 3 GPRs =====
                hdt -r1 -n4:3
                echo ===== node 2 socket 1 core 0 GPRs =====
                hdt -r1 -n5:0
                echo ===== node 2 socket 1 core 1 GPRs =====
                hdt -r1 -n5:1
                echo ===== node 2 socket 1 core 2 GPRs =====
                hdt -r1 -n5:2
                echo ===== node 2 socket 1 core 3 GPRs =====
                hdt -r1 -n5:3
            else
                echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
                echo '! Both sockets of node 2 are NOT powered on !'
                echo '!          hdt will NOT be executed         !'
                echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            fi
        elif [ ${TYPE} == 'Compute-AM2' ]; then
#           We can't tell the difference between AM2 dual
#           core and AM2 quad core so treat them as quad.
            echo ===== node 2 core 0 GPRs =====
            hdt -r1 -n2:0
            echo ===== node 2 core 1 GPRs =====
            hdt -r1 -n2:1
            echo ===== node 2 core 2 GPRs =====
            hdt -r1 -n2:2
            echo ===== node 2 core 3 GPRs =====
            hdt -r1 -n2:3
        else
#           We can't tell the difference between Opteron
#           single core and Opteron dual core so treat
#           them as dual.
            echo ===== node 2 core 0 GPRs =====
            hdt -r1 -n2:0
            echo ===== node 2 core 1 GPRs =====
            hdt -r1 -n2:1
        fi
    fi
    if [ ${TYPE} == 'Compute-FR2' ]; then
        if [ ${P3} == 0x43 ]; then
            echo ===== node 3 socket 0 core 0 GPRs =====
            hdt -r1 -n6:0
            echo ===== node 3 socket 0 core 1 GPRs =====
            hdt -r1 -n6:1
            echo ===== node 3 socket 0 core 2 GPRs =====
            hdt -r1 -n6:2
            echo ===== node 3 socket 0 core 3 GPRs =====
            hdt -r1 -n6:3
            echo ===== node 3 socket 1 core 0 GPRs =====
            hdt -r1 -n7:0
            echo ===== node 3 socket 1 core 1 GPRs =====
            hdt -r1 -n7:1
            echo ===== node 3 socket 1 core 2 GPRs =====
            hdt -r1 -n7:2
            echo ===== node 3 socket 1 core 3 GPRs =====
            hdt -r1 -n7:3
        else
            echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            echo '! Both sockets of node 3 are NOT powered on !'
            echo '!          hdt will NOT be executed         !'
            echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        fi
    elif [ ${TYPE} == 'Compute-AM2' ]; then
#       We can't tell the difference between AM2 dual
#       core and AM2 quad core so treat them as quad.
        echo ===== node 3 core 0 GPRs =====
        hdt -r1 -n3:0
        echo ===== node 3 core 1 GPRs =====
        hdt -r1 -n3:1
        echo ===== node 3 core 2 GPRs =====
        hdt -r1 -n3:2
        echo ===== node 3 core 3 GPRs =====
        hdt -r1 -n3:3
    else
#       We can't tell the difference between Opteron
#       single core and Opteron dual core so treat
#       them as dual.
        echo ===== node 3 core 0 GPRs =====
        hdt -r1 -n3:0
        echo ===== node 3 core 1 GPRs =====
        hdt -r1 -n3:1
    fi
    
    if [ ${TYPE} == 'Compute-FR2' ]; then
        if [ ${P0} == 0x43 ]; then
            echo ===== node 0 socket 0 northbridge =====
            hdt -m 0x401 -n0
            hdt -m 0x402 -n0
            hdt -m 0x405 -n0
            hdt -m 0x406 -n0
            hdt -m 0x409 -n0
            hdt -m 0x40a -n0
            hdt -m 0x40d -n0
            hdt -m 0x40e -n0
            hdt -m 0x411 -n0
            hdt -m 0x412 -n0
            hdt -m 0x414 -n0
            hdt -m 0x415 -n0
            echo ===== node 0 socket 1 northbridge =====
            hdt -m 0x401 -n1
            hdt -m 0x402 -n1
            hdt -m 0x405 -n1
            hdt -m 0x406 -n1
            hdt -m 0x409 -n1
            hdt -m 0x40a -n1
            hdt -m 0x40d -n1
            hdt -m 0x40e -n1
            hdt -m 0x411 -n1
            hdt -m 0x412 -n1
            hdt -m 0x414 -n1
            hdt -m 0x415 -n1
        else
            echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            echo '! Both sockets of node 0 are NOT powered on !'
            echo '!          hdt will NOT be executed         !'
            echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        fi
    else
        echo ===== node 0 northbridge =====
        hdt -m 0x401 -n0
        hdt -m 0x402 -n0
        hdt -m 0x405 -n0
        hdt -m 0x406 -n0
        hdt -m 0x409 -n0
        hdt -m 0x40a -n0
        hdt -m 0x40d -n0
        hdt -m 0x40e -n0
        hdt -m 0x411 -n0
        hdt -m 0x412 -n0
    fi
    if [ ${TYPE} != 'I/O' ]; then
        if [ ${TYPE} == 'Compute-FR2' ]; then
            if [ ${P1} == 0x43 ]; then
                echo ===== node 1 socket 0 northbridge =====
                hdt -m 0x401 -n2
                hdt -m 0x402 -n2
                hdt -m 0x405 -n2
                hdt -m 0x406 -n2
                hdt -m 0x409 -n2
                hdt -m 0x40a -n2
                hdt -m 0x40d -n2
                hdt -m 0x40e -n2
                hdt -m 0x411 -n2
                hdt -m 0x412 -n2
                hdt -m 0x414 -n2
                hdt -m 0x415 -n2
                echo ===== node 1 socket 1 northbridge =====
                hdt -m 0x401 -n3
                hdt -m 0x402 -n3
                hdt -m 0x405 -n3
                hdt -m 0x406 -n3
                hdt -m 0x409 -n3
                hdt -m 0x40a -n3
                hdt -m 0x40d -n3
                hdt -m 0x40e -n3
                hdt -m 0x411 -n3
                hdt -m 0x412 -n3
                hdt -m 0x414 -n3
                hdt -m 0x415 -n3
            else
                echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
                echo '! Both sockets of node 1 are NOT powered on !'
                echo '!          hdt will NOT be executed         !'
                echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            fi
        else
            echo ===== node 1 northbridge =====
            hdt -m 0x401 -n1
            hdt -m 0x402 -n1
            hdt -m 0x405 -n1
            hdt -m 0x406 -n1
            hdt -m 0x409 -n1
            hdt -m 0x40a -n1
            hdt -m 0x40d -n1
            hdt -m 0x40e -n1
            hdt -m 0x411 -n1
            hdt -m 0x412 -n1
        fi
        if [ ${TYPE} == 'Compute-FR2' ]; then
            if [ ${P2} == 0x43 ]; then
                echo ===== node 2 socket 0 northbridge =====
                hdt -m 0x401 -n4
                hdt -m 0x402 -n4
                hdt -m 0x405 -n4
                hdt -m 0x406 -n4
                hdt -m 0x409 -n4
                hdt -m 0x40a -n4
                hdt -m 0x40d -n4
                hdt -m 0x40e -n4
                hdt -m 0x411 -n4
                hdt -m 0x412 -n4
                hdt -m 0x414 -n4
                hdt -m 0x415 -n4
                echo ===== node 2 socket 1 northbridge =====
                hdt -m 0x401 -n5
                hdt -m 0x402 -n5
                hdt -m 0x405 -n5
                hdt -m 0x406 -n5
                hdt -m 0x409 -n5
                hdt -m 0x40a -n5
                hdt -m 0x40d -n5
                hdt -m 0x40e -n5
                hdt -m 0x411 -n5
                hdt -m 0x412 -n5
                hdt -m 0x414 -n5
                hdt -m 0x415 -n5
            else
                echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
                echo '! Both sockets of node 2 are NOT powered on !'
                echo '!          hdt will NOT be executed         !'
                echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            fi
        else
            echo ===== node 2 northbridge =====
            hdt -m 0x401 -n2
            hdt -m 0x402 -n2
            hdt -m 0x405 -n2
            hdt -m 0x406 -n2
            hdt -m 0x409 -n2
            hdt -m 0x40a -n2
            hdt -m 0x40d -n2
            hdt -m 0x40e -n2
            hdt -m 0x411 -n2
            hdt -m 0x412 -n2
        fi
    fi
    if [ ${TYPE} == 'Compute-FR2' ]; then
        if [ ${P3} == 0x43 ]; then
            echo ===== node 3 socket 0 northbridge =====
            hdt -m 0x401 -n6
            hdt -m 0x402 -n6
            hdt -m 0x405 -n6
            hdt -m 0x406 -n6
            hdt -m 0x409 -n6
            hdt -m 0x40a -n6
            hdt -m 0x40d -n6
            hdt -m 0x40e -n6
            hdt -m 0x411 -n6
            hdt -m 0x412 -n6
            hdt -m 0x414 -n6
            hdt -m 0x415 -n6
            echo ===== node 3 socket 1 northbridge =====
            hdt -m 0x401 -n7
            hdt -m 0x402 -n7
            hdt -m 0x405 -n7
            hdt -m 0x406 -n7
            hdt -m 0x409 -n7
            hdt -m 0x40a -n7
            hdt -m 0x40d -n7
            hdt -m 0x40e -n7
            hdt -m 0x411 -n7
            hdt -m 0x412 -n7
            hdt -m 0x414 -n7
            hdt -m 0x415 -n7
        else
            echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            echo '! Both sockets of node 3 are NOT powered on !'
            echo '!          hdt will NOT be executed         !'
            echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        fi
    else
        echo ===== node 3 northbridge =====
        hdt -m 0x401 -n3
        hdt -m 0x402 -n3
        hdt -m 0x405 -n3
        hdt -m 0x406 -n3
        hdt -m 0x409 -n3
        hdt -m 0x40a -n3
        hdt -m 0x40d -n3
        hdt -m 0x40e -n3
        hdt -m 0x411 -n3
        hdt -m 0x412 -n3
    fi
else
    echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
    echo '! All nodes are NOT powered on !'
    echo '!   hdt will NOT be executed   !'
    echo '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
fi
